--- gcc-3.4.6/gcc/Makefile.in	2013-05-19 20:08:05.000000000 +0200
+++ gcc/Makefile.in	2013-05-19 20:23:32.000000000 +0200
@@ -541,10 +541,36 @@
 # List of additional header files to install.
 EXTRA_HEADERS =@extra_headers_list@
 
+### begin-GG-local
+# List of extra targets that should be executed by make when building
+# the `doc' target.
+EXTRA_DOC_TARGETS =
+### end-GG-local
+
+### begin-GG-local
+# List of extra targets that should be executed by make when building
+# targets `stage1' to `stage4'.
+EXTRA_STAGE1_TARGETS =
+EXTRA_STAGE2_TARGETS =
+EXTRA_STAGE3_TARGETS =
+EXTRA_STAGE4_TARGETS =
+### end-GG-local
+
 # It is convenient for configure to add the assignment at the beginning,
 # so don't override it here.
 USE_COLLECT2 = collect2$(exeext)
 
+### begin-GG-local: dynamic libraries
+# List of extra object files that should be compiled and linked with
+# collect2.
+EXTRA_COLLECT2_OBJS =
+### end-GG-local
+
+### begin-GG-local
+# List of extra targets that should be executed by make when installing.
+EXTRA_INSTALL_TARGETS =
+### end-GG-local
+
 # List of extra C and assembler files to add to static and shared libgcc2.
 # Assembler files should have names ending in `.asm'.
 LIB2FUNCS_EXTRA =
@@ -651,6 +677,11 @@
 # at build time.
 SPECS = specs
 
+# Even if ALLOCA is set, don't use it if compiling with GCC, unless
+# a configuration file overrides this default.
+USE_ALLOCA= ` case "${CC}" in "${OLDCC}") echo "${ALLOCA}" ;; esac `
+USE_HOST_ALLOCA= ` case "${HOST_CC}"@"${HOST_ALLOCA}" in "${OLDCC}"@?*) echo ${HOST_PREFIX}${HOST_ALLOCA} ;; esac `
+
 # End of variables for you to override.
 
 # GTM_H lists the config files that the generator files depend on,
@@ -1186,6 +1217,7 @@
 	SHLIB_NM_FLAGS='$(SHLIB_NM_FLAGS)' \
 	MULTILIB_OSDIRNAMES='$(MULTILIB_OSDIRNAMES)' \
 	mkinstalldirs='$(SHELL) $(srcdir)/mkinstalldirs' \
+	LIBGCC_MULTI='$(LIBGCC_MULTI)' \
 	  $(SHELL) mklibgcc > tmp-libgcc.mk
 	mv tmp-libgcc.mk libgcc.mk
 
@@ -1351,7 +1383,9 @@
 sbitmap.o: sbitmap.c $(CONFIG_H) $(SYSTEM_H) coretypes.h $(TM_H) $(RTL_H) flags.h \
     hard-reg-set.h $(BASIC_BLOCK_H)
 
-COLLECT2_OBJS = collect2.o tlink.o intl.o version.o
+### begin-GG-local: dynamic libraries
+COLLECT2_OBJS = collect2.o tlink.o intl.o version.o $(EXTRA_COLLECT2_OBJS)
+### end-GG-local
 COLLECT2_LIBS = @COLLECT2_LIBS@
 collect2$(exeext): $(COLLECT2_OBJS) $(LIBDEPS)
 # Don't try modifying collect2 (aka ld) in place--it might be linking this.
@@ -2641,7 +2675,7 @@
 #
 # Remake the info files.
 
-doc: $(BUILD_INFO) $(GENERATED_MANPAGES) gccbug
+doc: $(BUILD_INFO) $(GENERATED_MANPAGES) gccbug $(EXTRA_DOC_TARGETS)
 
 INFOFILES = doc/cpp.info doc/gcc.info doc/gccint.info \
             doc/gccinstall.info doc/cppinternals.info
@@ -2810,7 +2844,7 @@
 	-rm -f config.h tconfig.h bconfig.h tm_p.h tm.h
 	-rm -f cs-*
 	-rm -rf libgcc
-	-rm -f doc/*.dvi
+	-rm -f doc/*.dvi doc/*.guide
 # Delete the include directory.
 	-rm -rf include
 # Delete files used by the "multilib" facility (including libgcc subdirs).
@@ -2870,7 +2904,7 @@
 # broken is small.
 install: install-common $(INSTALL_HEADERS) $(INSTALL_LIBGCC) \
     install-cpp install-man install-info install-@POSUB@ \
-    lang.install-normal install-driver
+    $(EXTRA_INSTALL_TARGETS) lang.install-normal install-driver
 
 # Handle cpp installation.
 install-cpp: cpp$(exeext)
@@ -3647,7 +3681,7 @@
 	  cp stage1/$${f} . ; \
 	else true; \
 	fi; done
-stage1: force stage1-start lang.stage1
+stage1: force stage1-start lang.stage1 $(EXTRA_STAGE1_TARGETS)
 	-for dir in . $(SUBDIRS) ; \
 	do \
 	  rm -f $$dir/*$(coverageexts) ; \
@@ -3684,7 +3718,7 @@
 	  cp stage2/$${f} . ; \
 	else true; \
 	fi; done
-stage2: force stage2-start lang.stage2
+stage2: force stage2-start lang.stage2 $(EXTRA_STAGE2_TARGETS)
 
 stage3-start:
 	-if [ -d stage3 ] ; then true ; else mkdir stage3 ; fi
@@ -3717,7 +3751,7 @@
 	  cp stage3/$${f} . ; \
 	else true; \
 	fi; done
-stage3: force stage3-start lang.stage3
+stage3: force stage3-start lang.stage3 $(EXTRA_STAGE3_TARGETS)
 
 stage4-start:
 	-if [ -d stage4 ] ; then true ; else mkdir stage4 ; fi
@@ -3750,7 +3784,7 @@
 	  cp stage4/$${f} . ; \
 	else true; \
 	fi; done
-stage4: force stage4-start lang.stage4
+stage4: force stage4-start lang.stage4 $(EXTRA_STAGE4_TARGETS)
 
 stageprofile-start:
 	-if [ -d stageprofile ] ; then true ; else mkdir stageprofile ; fi
